Imports Microsoft.VisualBasic
Imports System.Data
Imports System.Data.SqlClient
Imports System.Collections.Generic
Imports System.Web.Configuration

Public Class Paging

    Private _count As Integer = 0

    Public Function TotalUsuarios() As Integer
        Return Me._count
    End Function

    Public Function ResgataUsuarios(ByVal pageSize As Integer, _
        ByVal pageNumber As Integer) As Generic.List(Of Usuario)

        Dim coll As New Generic.List(Of Usuario)
        Dim conn As SqlConnection = _
            New SqlConnection( _
                WebConfigurationManager.ConnectionStrings("ConnString").ConnectionString)
        Dim cmd As New SqlCommand("CustomPaging", conn)

        cmd.CommandType = CommandType.StoredProcedure
        cmd.Parameters.AddWithValue("@PageSize", pageSize)
        cmd.Parameters.AddWithValue("@PageNumber", pageNumber)
        cmd.Parameters.AddWithValue("@RETURN_VALUE", 0).Direction = _
            ParameterDirection.ReturnValue

        Dim dr As SqlDataReader = Nothing
        Try
            conn.Open()
            dr = cmd.ExecuteReader(Data.CommandBehavior.CloseConnection)
            While dr.Read()
                Dim u As New Usuario
                With u
                    .Nome = dr.GetString(0)
                End With
                coll.Add(u)
            End While
        Finally
            If Not IsNothing(dr) Then
                dr.Close()
            End If

            Me._count = _
                Convert.ToInt32(cmd.Parameters("@RETURN_VALUE").Value)
        End Try
        Return coll
    End Function

End Class
