Imports Microsoft.VisualBasic
Imports System.Data.SqlClient
Imports System.Web.Configuration

Public Class Usuarios

    Public Sub Delete(ByVal original_ID As Integer)
        Dim conn As New _
            SqlConnection(WebConfigurationManager.ConnectionStrings("ConnString").ConnectionString)
        Dim cmd As New _
            SqlCommand("DELETE FROM Usuario WHERE UsuarioID = @ID", conn)

        cmd.Parameters.AddWithValue("@ID", original_ID)

        Try
            conn.Open()
            cmd.ExecuteNonQuery()
        Finally
            If Not IsNothing(conn) Then
                conn.Close()
            End If
        End Try
    End Sub

    Public Sub Update(ByVal nome As String, ByVal email As String, ByVal id As Integer)
        Dim conn As New _
            SqlConnection(WebConfigurationManager.ConnectionStrings("ConnString").ConnectionString)
        Dim cmd As New _
            SqlCommand("UPDATE Usuario SET Nome = @Nome, Email = @Email WHERE UsuarioID = @ID", conn)

        cmd.Parameters.AddWithValue("@Nome", nome)
        cmd.Parameters.AddWithValue("@Email", email)
        cmd.Parameters.AddWithValue("@ID", id)

        Try
            conn.Open()
            cmd.ExecuteNonQuery()
        Finally
            If Not IsNothing(conn) Then
                conn.Close()
            End If
        End Try
    End Sub

    Public Sub Update(ByVal u As Usuario)
        Dim conn As New _
            SqlConnection(WebConfigurationManager.ConnectionStrings("ConnString").ConnectionString)
        Dim cmd As New _
            SqlCommand("UPDATE Usuario SET Nome = @Nome, Email = @Email WHERE UsuarioID = @ID", conn)

        cmd.Parameters.AddWithValue("@Nome", u.Nome)
        cmd.Parameters.AddWithValue("@Email", u.Email)
        cmd.Parameters.AddWithValue("@ID", u.ID)

        Try
            conn.Open()
            cmd.ExecuteNonQuery()
        Finally
            If Not IsNothing(conn) Then
                conn.Close()
            End If
        End Try
    End Sub

    Public Function ResgataUsuarios() As Generic.List(Of Usuario)
        Return ResgataUsuarios(String.Empty)
    End Function

    Public Function ResgataUsuarios(ByVal coluna As String) As Generic.List(Of Usuario)
        Dim coll As New Generic.List(Of Usuario)
        Dim conn As New _
            SqlConnection(WebConfigurationManager.ConnectionStrings("ConnString").ConnectionString)
        Dim query As String = "SELECT UsuarioID, Nome, Email FROM Usuario"

        If Not coluna = String.Empty Then
            query &= " ORDER BY " + coluna
        End If

        Dim cmd As New SqlCommand(query, conn)
        Dim dr As SqlDataReader = Nothing
        Try
            conn.Open()
            dr = cmd.ExecuteReader(Data.CommandBehavior.CloseConnection)
            While dr.Read()
                Dim u As New Usuario
                With u
                    .ID = dr.GetInt32(0)
                    .Nome = dr.GetString(1)
                    .Email = dr.GetString(2)
                End With
                coll.Add(u)
            End While
        Finally
            If Not IsNothing(dr) Then
                dr.Close()
            End If
        End Try
        Return coll
    End Function

End Class
